aboutsummaryrefslogtreecommitdiffhomepage
path: root/test/test-lib.sh
diff options
context:
space:
mode:
authorGravatar Pieter Praet <pieter@praet.org>2012-01-14 10:09:37 +0100
committerGravatar David Bremner <bremner@debian.org>2012-01-15 22:37:07 -0400
commit42e8f66edf91095bb87b3ee7713b94002ffd3edc (patch)
treeef58249ab47e7754c0e09bc7f0f2ab05a18ccb1d /test/test-lib.sh
parentef5c1d73f8e736425682dc4db0ce285e6e2de0f5 (diff)
test: don't bail out of `run_emacs' too early when missing prereqs
When running the Emacs tests in verbose mode, only the first missing prereq is reported because the `run_emacs' function is short-circuited early: #+begin_example emacs: Testing emacs interface missing prerequisites: [0] emacs(1) skipping test: [0] Basic notmuch-hello view in emacs SKIP [0] Basic notmuch-hello view in emacs #+end_example This can lead to situations reminiscent of "dependency hell", so instead of returning based on each individual `test_require_external_prereq's exit status, we now do so only after checking all the prereqs: #+begin_example emacs: Testing emacs interface missing prerequisites: [0] dtach(1) emacs(1) emacsclient(1) skipping test: [0] Basic notmuch-hello view in emacs SKIP [0] Basic notmuch-hello view in emacs #+end_example Also added missing prereq for dtach(1).
Diffstat (limited to 'test/test-lib.sh')
-rw-r--r--test/test-lib.sh7
1 files changed, 5 insertions, 2 deletions
diff --git a/test/test-lib.sh b/test/test-lib.sh
index 82767c07..d1fbc054 100644
--- a/test/test-lib.sh
+++ b/test/test-lib.sh
@@ -907,8 +907,11 @@ EOF
test_emacs () {
# test dependencies beforehand to avoid the waiting loop below
- test_require_external_prereq emacs || return
- test_require_external_prereq emacsclient || return
+ missing_dependencies=
+ test_require_external_prereq dtach || missing_dependencies=1
+ test_require_external_prereq emacs || missing_dependencies=1
+ test_require_external_prereq emacsclient || missing_dependencies=1
+ test -z "$missing_dependencies" || return
if [ -z "$EMACS_SERVER" ]; then
server_name="notmuch-test-suite-$$"